<?php
/**
 *权限操作模型类
 */
namespace app\common\model;
use think\Model;
use think\Db;
use think\Log;

class Authority extends Model
{
	private $inoutTableOk = false;
	//查询权限信息
	function getAuthRule($patientInfo,$ewm)
	{
		if(!$patientInfo) return ['d'=>'','s'=>'','b'=>''];

		$db = Db::connect(config('database.db_config_mysql_1'));

		$pa = $db->name('patient_authority')
			->where('zhuyuanhao',$patientInfo['ZHUYUANHAO'])
			->find();
		//查询患者自身权限
		$u = [];
		$o = [];
		//用户自定义的
		if($pa['rule'])
		{
			$u = json_decode($pa['rule'],true);	
		}
		//从HIS系统对接的
		if($pa['authority_id'] != 0)
		{
			$os_rule = $db->name('authority')->where('id='.$pa['authority_id'])->value('rule');
			if($os_rule)
			{
				$o = json_decode($os_rule,true);
			}
		}
		
		$result['b'] = '';
		//查询所属病房权限
		$result['b'] = $db->name('authority')
			->alias('a')
			->join('__OBJECT_AUTHORITY__ oa', 'a.id=oa.authority_id')
			->where("oa.object_id={$patientInfo['BINGQUCODE']} and oa.type=2")
			->value('rule');
		if($pa['b_auth'] == 0 && $result['b'] != '')//继承病区权限，并且病区权限不为空
		{
			$b = json_decode($result['b'],true);
			if($pa['authority_id'] == 5)//陪住权限恶心，特殊处理
			{
		        //工作日对应结果为0, 休息日对应结果为1, 节假日对应的结果为2
		        $holidays = config('holidays');
		        $festive = $holidays[date('md')] ?? 0;
		        $hi = date('H:i');
		        $week = date('N');
				foreach ($b as $k => $r)
				{
					//星期和法定假日
		            $weeks = explode(',',$r['week']);
		            if(in_array($week,$weeks) || (end($weeks) == 8 && $festive > 0))
		            {
						list($st,$et) = explode('-',$r['time']);
						if($hi >= $st && $hi <= $et && isset($o[0]))
						{
		                    if($r['number'] != '' && $o[0]['number'] != '')
		                        $b[$k]['number'] = $r['number']-$o[0]['number'];
		                    if($r['cishu'] != '' && $o[0]['cishu'] != '')
		                        $b[$k]['cishu'] = 0;  
		                }
		                else
		                	unset($b[$k]);
		            }
		            else
		            	unset($b[$k]);
				}
				$b = array_values($b);
				$result['b'] = json_encode($b);
			}	
			else if($pa['authority_id'] == 1)//普通权限
			{
				$o = [];//继承病区权限，就走病区权限
			}
		}
		else//不继续病区权限
		{
			$result['b'] = '';//那么病区权限设置为空
		}

		$result['s'] = json_encode(array_merge($u,$o));//合并自定义权限和his对接权限
		//查询家属权限
		$result['d'] = '';
		if($pa['pz_status'] == 1 || $pa['jc_status'] == 1)
		{
			if($pa['pz_status'] == 1 && $pa['jc_status'] == 1)
			{
				$auth_id = '';
			}
			else if($pa['pz_status'] == 1)
			{
				$auth_id = ' and authority_id=5';
			}
			else if($pa['jc_status'] == 1)
			{
				$auth_id = ' and authority_id=4';
			}
			$did = $db->name('dependents')->where("zhuyuanhao='{$patientInfo['ZHUYUANHAO']}' and shenfenzheng='{$ewm['shenfenzheng']}'")
				->value('id');
			if($did)
			{
				$result['d'] = $db->name('authority')
					->alias('a')
					->join('__OBJECT_AUTHORITY__ oa', 'a.id=oa.authority_id')
					->where("oa.object_id={$did} and oa.type=3{$auth_id}")
					->value('rule');
			}
		}
		return $result;
	}
	//查询次数和人数
	function getInout($param)
	{
		$param['no'] = $param['no'] ?? '';
		$param['zhuyuanhao'] = $param['zhuyuanhao'] ?? '';

		$db = Db::connect(config('database.db_config_mysql_1'));
		$table = $this->createInoutTable();

		$map = [];
		$map['time'] = [['egt',date('Y-m-d').' '.$param['st'].':00'],
		['elt',date('Y-m-d').' '.$param['et'].':59']];
		//人数
		if($param['a'] == 'r')
		{
			$map['zhuyuanhao'] = $param['zhuyuanhao'];
			$row_g = $db->table($table)->where($map)->group('no')->field('count(no) as cnt')->select();
			$cnt = 0;
			foreach ($row_g as $rg) {
				if($rg['cnt'] % 2 == 1)
					$cnt++;
			}
		}
		//次数;
		if($param['a'] == 'c')
		{
			$map['direction'] = 0;
			$map['zhuyuanhao'] = $param['zhuyuanhao'];
			$map['no'] = $param['no'];
			$cnt = $db->table($table)->where($map)->count();
		}
		return $cnt;
	}
	//扫码入库
	function saoma($no,$zyh,$mid,$direction)
	{
		$db = Db::connect(config('database.db_config_mysql_1'));
		$table = $this->createInoutTable();
		$map = [];
		if($direction == 0)
		{
			$map['no'] = $no;
			$map['time'] = ['egt',date('Y-m-d')];
			$dn = $db->table($table)
				->where($map)
				->order('time desc')
				->value('direction');
			if($dn === 0)
			{
				return 'Enter already';//这样可以避免多个人使用同一个二维码
			}
		}
		if($direction == 1)
		{
			$map['no'] = $no;
			$dn = $db->table($table)
				->where($map)
				->order('time desc')
				->value('direction');
			if($dn === null || $dn === 1)
			{
				return 'Exit Error';
			}
		}
		$result = $db->table($table)->insert([
			'no' => $no,
			'zhuyuanhao' => $zyh,
			'direction' => $direction,
			'mid' => $mid,
		]);
		return $result;
	}
	//创建二维码进出闸机日志表
	private function createInoutTable()
	{
		$db = Db::connect(config('database.db_config_mysql_1'));
		$inout_table = config('database.db_config_mysql_1')['prefix'].'ewm_inout_'.date('Ym');
		if($this->inoutTableOk == false)
		{
		$createSql = <<<EOT
create table if not exists {$inout_table}(
    `id` int(11) primary key AUTO_INCREMENT comment '主键',
    `no` varchar(20) not null comment '二维码编码',
    `zhuyuanhao` varchar(12) not null comment '住院号',
    `direction` tinyint(1) not null comment '类型0进,1出',
    `time` timestamp NULL DEFAULT CURRENT_TIMESTAMP comment '进出时间',
    `mid` char(4) NOT NULL COMMENT '闸机读卡器ID',
    key i_time(time),
    key `i_zdt` (`zhuyuanhao`,`direction`,`time`),
  	key `i_ndt` (`no`,`direction`,`time`)
)engine=innodb AUTO_INCREMENT=1 default charset=utf8 comment='二维码表进出日志按年月分表';
EOT;
		$result = $db->query($createSql);
		$this->inoutTableOk = true;
		}
		return $inout_table;
	}
	//处理的患者权限表记录
	function manPatientAuth()
	{

		$today = date('Y-m-d');

		$logData['Start'] = $today;

		$db = Db::connect(config('database.db_config_mysql_1'));

		$rows = $db->name('patient_authority')->where("is_out=1 or is_die=1 or is_operation_z=1 or is_operation_j=2")->select();
		
		$logData['Rows'] = $rows;

		foreach($rows as $r)
		{
			//出院或者死亡
			if($r['is_out'] == 1 or $r['is_die'] == 1)
			{
				$die_out = false;
				$modify_data = ['rule'=>'','b_auth'=>1];
				if($r['is_out'] == 1 && $r['out_date'] < $today)
				{
					$die_out = true;
					$modify_data['is_out'] = 2;
				}
				if($r['is_die'] == 1 && $r['die_date'] < $today)
				{
					$die_out = true;
					$modify_data['is_die'] = 2;
				}
				if($die_out)
				{
					//删除家属权限
					$modify_data['pz_status'] = 0;
					$modify_data['jc_status'] = 0;
					//删除患者自身权限和所属病房权限
					$db->name('patient_authority')
					->where("zhuyuanhao = '{$r['zhuyuanhao']}'")->update($modify_data);
					//$prefix = config('database.db_config_mysql_1')['prefix'];
					//$db->execute("delete o from {$prefix}object_authority o,{$prefix}dependents d where o.object_id=d.id and type=3 and zhuyuanhao='{$r['zhuyuanhao']}'");
				}
			}
			//择期手术术前一日改为手术权限
			if($r['is_operation_z'] == 1 && ($today >= date('Y-m-d',strtotime('-1 day',$r['operation_z_date']))))
			{
				$rule = $db->name('authority')->where('id=3')->value('rule');

				$db->name('patient_authority')
				->where("zhuyuanhao='{$r['zhuyuanhao']}'")
				->update(['rule'=>$rule,'is_operation_z'=>2]);
			}
			//急诊手术结束次日改为普通探视权限
			if($r['is_operation_j'] == 2 && strtotime('+1 day',$r['operation_j_date']) >= $today)
			{
				$db->name('patient_authority')
				->where("zhuyuanhao='{$r['zhuyuanhao']}'")
				->update(['rule'=>'','is_operation_j'=>0]);
			}
		}
		$logData['End'] = $today;
		Log::write($logData,'info.task');
	}
	//更新设备活跃时间没有就增加
	public function updateDev($code,$ip)
	{
		$db = Db::connect(config('database.db_config_mysql_1'));
		$row = $db->name('dev')->where("code='$code'")->find();
		//奇数进,偶数出
		$direction = intval($code)%2 == 0 ? 1 : 0;
		$data = [
			'code' => $code,
			'active_time' => time(),
			'ip' => ip2long($ip),
			//'direction'=> $direction,
		];
		if($row)
		{
			$db->name('dev')->where('code',$code)->update($data);
		}
		else
		{
			$db->name('dev')->insert($data);
		}
		$kv_config = $db->name('config')->where("`key`='ONE_OPEN'")->field('value')->find();
		return $kv_config['value'];
	}
	//根据ID获取权限
	public function getAuthById($id)
	{
		$db = Db::connect(config('database.db_config_mysql_1'));
		$row = $db->name('authority')->where('id',$id)->find();
		return $row;
	}
}