<?php
/**
 *连接oracle公共模型类
 */
namespace app\common\model;
use think\Model;
use think\Db;
use think\Log;
/**
 *存储过程
 *view_rwzb_patientinfo住院患者信息
 *view_rwzb_visit_special his系统里的探视设置
 *view_rwzb_item 医嘱字典
 *view_rwzb_ipm 医嘱
 */
class Oracle extends Model
{
	//根据住院号查询患者信息
	function getPatientinfo($zhuyuanhao)
	{ 
		$db_config_oracle_zz = Db::connect(config('database.db_config_oracle_zz'));
		$row = $db_config_oracle_zz->name('view_rwzb_patientinfo')->where('ZHUYUANHAO',$zhuyuanhao)->field("ZHUYUANHAO,TELPHONE,TO_CHAR(IN_TIME,'YYYY-MM-DD') IN_TIME,BINGQUCODE,KESHICODE,SHENFENZHENG,PAT_NAME,YNOUT,TO_CHAR(OUTDATE,'YYYY-MM-DD') OUTDATE,TO_CHAR(SHOUSHURQ,'YYYY-MM-DD') SHOUSHURQ,(CASE YN_SHOUSHU WHEN '是' THEN 1 ELSE 0 END) YN_SHOUSHU,(CASE YN_ICU WHEN '是' THEN 1 ELSE 0 END) YN_ICU")->find();
		$sqls = $db_config_oracle_zz->getLastSql();
		if($row)
		{
			$row['YN_SHOUSHU_NOW'] = 0;
			$row['YN_JC'] = 0;
			$row['VISIT_SPECIAL']['YNSTAY'] = 0;
			$row['VISIT_SPECIAL']['VISITCAUSE'] = '';
			/**手术权限start**/
			//1.择期手术
			if($row['YN_SHOUSHU'] == 1)
			{
				//手术前一天变为手术权限
				if(date('Y-m-d') >= date('Y-m-d',strtotime($row['SHOUSHURQ'])-86400))
					$row['YN_SHOUSHU_NOW'] = 1;
			}
			//2.医嘱里特殊项目当作手术去处理
			//医嘱项目字典
			$items = $db_config_oracle_zz->name('view_rwzb_item')->where("ITEMNAME in('备皮（住院）')")->column('ITEMCODE');
			$sqls .= '#';
			$sqls .= $db_config_oracle_zz->getLastSql();
			$items = array_keys($items);
			$items_str = implode("','", $items);
			$items_str = "'".$items_str."'";

			//统一读医嘱
			$ipm_row = $db_config_oracle_zz->name('view_rwzb_ipm')->where("ZHUYUANHAO='$zhuyuanhao' AND (ITEMNAME='留陪一人' OR ITEMNAME='出院通知' OR YN_JC=1 OR ITEMCODE in ({$items_str}) OR ITEMNAME LIKE '%造影%' OR ITEMNAME LIKE '%介入治疗%')")->field("YN_JC,ITEMCODE,ITEMNAME,TO_CHAR(USETIME,'YYYY-MM-DD') USETIME_YMD")->select();
			$sqls .= '#';
			$sqls .= $db_config_oracle_zz->getLastSql();
			$today = date('Y-m-d');
			$jcday = date('Y-m-d',strtotime('-2 day'));
			$ssday = date('Y-m-d',strtotime('-1 day'));
			foreach ($ipm_row as $ipk => $ipv) {
				//手术
				if($ipv['USETIME_YMD'] >= $ssday)
				{
					if(in_array($ipv['ITEMCODE'],$items) || strstr($ipv['ITEMNAME'],'造影') || strstr($ipv['ITEMNAME'],'介入治疗'))
					{
						$row['YN_SHOUSHU_NOW'] = 1;
					}
				}
				//陪住
				if($ipv['ITEMNAME'] == '留陪一人')
				{
					$row['VISIT_SPECIAL']['YNSTAY'] = 1;
				}
				//出院
				if($ipv['ITEMNAME'] == '出院通知')
				{
					$row['YNOUT'] = 1;
					$row['OUTDATE'] = $ipv['USETIME_YMD'];
				}
				//检查
				if($ipv['YN_JC'] == 1 && $ipv['USETIME_YMD'] >= $jcday)
				{
					$row['YN_JC'] = 1;
				}
			}
			//查询所属病区
			$unit = $db_config_oracle_zz->name('view_rwzb_unit')->where('BINGQUCODE',$row['BINGQUCODE'])->field('BINGQU,POSITION')->find();
			$row['BINGQU'] = $unit['BINGQU'] ?? '未知';
			$row['POSITION'] = $unit['POSITION'] ?? '请看楼层索引';
		}
		Log::write(['sql'=>$sqls, 'data'=>$row],'info.his');
		return $row;
	}
	//测试专用
	public function getsql($sql)
	{
        $db_config_oracle_zz = Db::connect(config('database.db_config_oracle_zz'));
        $row = array();
        if(is_array($sql))
        {
        	foreach ($sql as $k => $v) {
        		$row[$k] = $db_config_oracle_zz->query($v);
        	}
        }
        else
        	$row = $db_config_oracle_zz->query($sql);
		return $row;
	}
}