<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006~2018 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: liu21st <liu21st@gmail.com>
// +----------------------------------------------------------------------
use think\Env;
return [
    'db_config_mysql_1'=>[
        // 数据库类型
        'type'            => 'mysql',
        // 服务器地址
        'hostname'        => Env::get('mysql.hostname'),
        // 数据库名
        'database'        => Env::get('mysql.database'),
        // 用户名
        'username'        => Env::get('mysql.username'),
        // 密码
        'password'        => Env::get('mysql.password'),
        // 端口
        'hostport'        => Env::get('mysql.hostport'),
        // 连接dsn
        'dsn'             => '',
        // 数据库连接参数
        'params'          => [],
        // 数据库编码默认采用utf8
        'charset'         => 'utf8',
        // 数据库表前缀
        'prefix'          => 'gate_',
        // 数据库调试模式
        'debug'           => true,
        // 数据库部署方式:0 集中式(单一服务器),1 分布式(主从服务器)
        'deploy'          => 0,
        // 数据库读写是否分离 主从式有效
        'rw_separate'     => false,
        // 读写分离后 主服务器数量
        'master_num'      => 1,
        // 指定从服务器序号
        'slave_no'        => '',
        // 自动读取主库数据
        'read_master'     => false,
        // 是否严格检查字段是否存在
        'fields_strict'   => true,
        // 数据集返回类型
        'resultset_type'  => 'array',
        // 自动写入时间戳字段
        'auto_timestamp'  => false,
        // 时间字段取出后的默认时间格式
        'datetime_format' => 'Y-m-d H:i:s',
        // 是否需要进行SQL性能分析
        'sql_explain'     => false,
        // Builder类
        'builder'         => '',
        // Query类
        'query'           => '\\think\\db\\Query',
        // 是否需要断线重连
        'break_reconnect' => false,
        // 断线标识字符串
        'break_match_str' => [],
    ],

    //住院
    'db_config_oracle_zz' => [
        'type'   => '\think\oracle\Connection', // 数据库类型
        //'hostname'   => '172.28.1.101', // 服务器地址
        //'database'   => '(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.28.1.101)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA901)))', // 数据库名
        'username'   => 'rwzb', // 用户名
        'password'    => 'rwzb', // 密码
        //'hostport'   => 1521, // 端口
        'dsn'        => 'oci:dbname=(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.28.1.101)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA901)));charset=UTF8',
        'prefix' => '' ,// 数据库表前缀
        'charset'=> 'utf8', // 字符集
        'params'=> [
            'persist'=>true,
            ],
    ],

    //自助
    'db_config_oracle_zy' => [
        'type'   => '\think\oracle\Connection', // 数据库类型
        //'hostname'   => '172.18.20.1', // 服务器地址
        'database'   => '(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.18.20.1)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA920)))', // 数据库名
        'username'   => 'zhgh_rwzb', // 用户名
        'password'    => 'zhgh_rwzb', // 密码
        //'hostport'   => 1521, // 端口
        //'dns' => 'db_config_oracle_zz' => 'oci:dbname=(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.18.20.1)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA920)));charset=utf8',
        'prefix' => '' ,// 数据库表前缀 
        'charset'=> 'utf8', // 字符集
        'params'=> [
            'persist'=>true,
            ],
    ],

    //'db_config_oracle_zy' => 'oci:dbname=(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.28.1.101)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA901)));charset=utf8',

    //'db_config_oracle_zz' => 'oci:dbname=(DESCRIPTION =(ADDRESS_LIST =(ADDRESS = (PROTOCOL = TCP)(HOST = 172.18.20.1)(PORT = 1521)))(CONNECT_DATA =(SERVICE_NAME = ORA920)));charset=utf8',
];
