<?php
namespace app\frontend\controller;
use think\Controller;
use think\Validate;
use think\Request;
use Endroid\QrCode\QrCode;
use extend\Crypt3Des;
use think\Log;
class Index extends Controller
{
    public function index()
    {
        return 'frontend';
    }
    public function insertEwm()
    {
        $rule = [
            //['name','require|max:25','请刷身份证获取姓名|姓名最多不能超过16个字符'],
            ['shenfenzheng','require','请进行身份验证'],
            //['mobile','require|mobile','请输入手机号|手机号格式不正确'],
            ['zhuyuanhao','require|max:25','请输入患者住院号|患者住院号最多不能超过12个字符'],
            //['p_mobile','require|\d{4}','请输入患者手机号后四位|患者手机号格式不正确'],
        ];
        $validate = Validate::make($rule);
        $result = $validate->batch()->check(Request::instance()->post());
        if(!$result)
        {
            $this->error($validate->getError());
        }
        if(!preg_match("/^\d{17}(\d|X){1}$/",input('post.shenfenzheng')) && !preg_match("/^\d{14}$/",input('post.shenfenzheng')) && !preg_match("/^\d{12}$/",input('post.shenfenzheng')))
        {
            $this->error(array('shenfenzheng'=>"身份验证格式不正确"));
        }
        else if(preg_match("/^\d{17}(\d|X){1}$/",input('post.shenfenzheng')) && !isIdCard(input('post.shenfenzheng')))
        {
            $this->error(array('shenfenzheng'=>"身份证号不合法"));
        }

        if(!in_array(input('post.persons'), array(1,2)))
        {
            $this->error(array('persons'=>"来访人数非法"));
        }
        if(input('post.mobile') != '' && !preg_match("/^\d{11}$/",input('post.mobile')))
        {
            $this->error(array('mobile'=>"手机号格式不正确"));
        }
        $patientInfo = model('Oracle')->getPatientinfo(input('post.zhuyuanhao'));
        if(empty($patientInfo))
        {
            $this->error(array('zhuyuanhao'=>"此住院号不存在,请重新输入"));
        }
        if(!empty($patientInfo['OUTDATE']) && $patientInfo['OUTDATE'] <= date('Y-m-d',strtotime('-2 day')))
        {
            $this->error(array('zhuyuanhao'=>"您要探视的患者已经出院"));
        }
        /*
        if(input('post.p_mobile') != '' && !preg_match("/^\d{4}$/",input('post.p_mobile')))
        {
            $this->error(array('p_mobile'=>"患者手机号格式不正确"));
        }
        if($patientInfo['TELPHONE'] != '未提供')
        {
            if(input('post.p_mobile') == '')
            {
                $this->error(array('p_mobile'=>"请输入患者手机号后四位"));
            }
            if(substr($patientInfo['TELPHONE'],-4) != input('post.p_mobile'))
            {
                $this->error(array('p_mobile'=>"患者手机号后四位不正确,请重新输入"));
            }
        }
        */
        $ewm = model('Ewm');
        $result = $ewm->insertEwm(Request::instance()->post(),$patientInfo);
        if($result['res'])
        {
            /*
            import('Crypt3Des', EXTEND_PATH);
            $Crypt3Des = new Crypt3Des();
            $no = $Crypt3Des->encrypt($no);
            */
            if($result['error'])
            {
                $this->error(array('result'=>$result['error']));
            }
            $rules = model('Authority')->getAuthRule($patientInfo,['shenfenzheng'=>'']);
            $rule = $this->manRule(input('post.zhuyuanhao'),$rules);
            $this->success("登记成功",'',[
                'row'=>$result['data']['row'],
                'pat_name'=>$patientInfo['PAT_NAME'],
                'bingqu' => $patientInfo['BINGQU'],
                'position' => $patientInfo['POSITION'],
                'date'=>date('Y-m-d'),
                'time'=>date('H:i:s'),
                'rule'=>$rule,
            ]);
        }
        else
        {
            $this->error(array('result'=>"登记失败"));
        }
    }
    //访客信息录入
    public function guest()
    {
        $row = model('Authority')->getAuthById(1);
        $this->assign('ifu',$row['remark']);
        return $this->fetch();
    }
    //生成电子二维码
    public function createEwm($code,$size = 200)
    {
        $qrCode = new QrCode();
        $qrCode->setText($code)
            ->setSize($size)//大小
            ->setLabelFontPath(VENDOR_PATH.'endroid/qrcode/assets/noto_sans.otf')
            ->setErrorCorrectionLevel('high')
            ->setForegroundColor(array('r' => 0, 'g' => 0, 'b' => 0, 'a' => 0))
            ->setBackgroundColor(array('r' => 255, 'g' => 255, 'b' => 255, 'a' => 0))
            ->setLabelFontSize(16);
        header('Content-Type: '.$qrCode->getContentType());
        echo $qrCode->writeString();
    }
    //进闸机扫码
    public function saomain($no,$mid)
    {
        if(empty($no))
        {
            return output(['code'=>'07','msg'=>'param参数不能为空','data'=>[]]);
        }
        /*
        import('Crypt3Des', EXTEND_PATH);
        $Crypt3Des = new Crypt3Des();
        $no = $Crypt3Des->decrypt($no);
        */
        $ewm = model('Ewm')->getZyhByNo($no);
        $zhuyuanhao = $ewm['zhuyuanhao'];
        if(empty($zhuyuanhao))
        {
            return output(['code'=>'10','msg'=>'系统发生错误,找不到此二维码对应的住院号','data'=>[]]);
        }
        if(substr($ewm['addtime'],0,10) != date('Y-m-d'))
        {
            return output(['code'=>'12','msg'=>'此二维码已失效','data'=>[]]);
        }
        $patientInfo = model('Oracle')->getPatientinfo($zhuyuanhao);

        if(empty($patientInfo))
        {
            return output(['code'=>'02','msg'=>'住院患者不存在','data'=>[]]);
        }

        //初始化权限
        model('Ewm')->auth_init($zhuyuanhao,$patientInfo);
        //判断权限逻辑
        $authority = model('Authority');
        //1.患者入住当日不限使用次数
        /*
        if(substr($patientInfo['IN_TIME'],0,10) == date('Y-m'))
        {
            return output(['code'=>'00','msg'=>'允许进入','data'=>[]]);
        }
        */
        //查询患者所属的权限
        $rules = $authority->getAuthRule($patientInfo,$ewm);
        if(empty($rules))
        {
            return output(['code'=>'99','msg'=>'系统发生错误,找不到相关的任何权限','data'=>[]]);
        }
        /**
         * a.陪住或外出检查权限优先级最高并且不累加
         * b.患者自身权限和病区权限累加
         */
        $rule = [];
        $rule_d = [];
        $rule_b = [];
        $rule_s = [];
        //转换成json
        if($rules['d'])
        {
            $rule_d = json_decode($rules['d'],true);
        }
        if($rules['b'])
        {
            $rule_b = json_decode($rules['b'],true);
        }
        if($rules['s'])
        {
            $rule_s = json_decode($rules['s'],true);
        }
        if(count($rule_d) > 0)//陪住或外出检查权限
        {
            $rule = $rule_d;
        }
        else
        {
            if(count($rule_s) > 0)
                $rule = array_merge($rule,$rule_s);
            if(count($rule_b) > 0)
                $rule = array_merge($rule,$rule_b);
        }
        if(empty($rule))
        {
            return output(['code'=>'98','msg'=>'系统发生错误,找不到相关的任何权限','data'=>[]]);
        }
        //工作日对应结果为0, 休息日对应结果为1, 节假日对应的结果为2
        $holidays = config('holidays');
        $festive = $holidays[date('md')] ?? 0;
        $hi = date('H:i');
        $week = date('N');

        $date_bool = false;
        $time_bool = false;
        $nc = [];
        $key = $week.'_'.$hi;
        //权限合并
        foreach ($rule as $r) 
        {
            //星期和法定假日
            $weeks = explode(',',$r['week']);
            if(in_array($week,$weeks) || (end($weeks) == 8 && $festive > 0))
            {
                $date_bool = true;
                list($st,$et) = explode('-',$r['time']);
                if($hi >= $st && $hi <= $et)
                {
                    $time_bool = true;
                    //不限制给86400
                    if($r['number'] === '')
                        $r['number'] = 86400;
                    if($r['cishu'] === '')
                        $r['cishu'] = 86400;  

                    $nc[$key]['number'] = $nc[$key]['number'] ?? 0;
                    $nc[$key]['cishu'] = $nc[$key]['cishu'] ?? 0;

                    $nc[$key]['number'] += $r['number'];
                    $nc[$key]['cishu'] += $r['cishu'];
                }
            }
        }
        if(!$time_bool)
            return output(['code'=>'03','msg'=>'时间不符合规则','data'=>[]]);
        if(!$date_bool)
            return output(['code'=>'04','msg'=>'日期不符合规则','data'=>[]]);
        $st = '00:00';//今日零点
        $et = $hi;
        if(isset($nc[$key]['cishu']))
        {
            //次数
            $inout_c = $authority->getInout([
                'a'=>'c',
                'zhuyuanhao'=>$zhuyuanhao,
                'no'=>$no,
                'st'=>$st,
                'et'=>$et
            ]);
            if($inout_c >= $nc[$key]['cishu'])
            {
                 return output(['code'=>'05','msg'=>'次数不符合规则','data'=>[]]);
            }
        }
        if(isset($nc[$key]['number']))
        {
            //人数，现在调整从总人数到同时进入病区的人数
            $inout_n = $authority->getInout([
                'a'=>'r',
                'zhuyuanhao'=>$zhuyuanhao,
                'no'=>$no,
                'st'=>$st,
                'et'=>$et
            ]);
            if($inout_n >= $nc[$key]['number'])
            {
                 return output(['code'=>'06','msg'=>'人数不符合规则','data'=>[]]);
            }
        }
        $result = $authority->saoma($no,$zhuyuanhao,$mid,0);
        if($result == 'Enter already')
        {
             return output(['code'=>'08','msg'=>'已经进入闸机','data'=>[]]);
        }
        return output(['code'=>'00','msg'=>'允许进入','data'=>[]]);
    }
    //出闸机扫码
    public function saomaout($no,$mid)
    {
        if(empty($no))
        {
            return output(['code'=>'07','msg'=>'param参数不能为空','data'=>[]]);
        }
        /*
        import('Crypt3Des', EXTEND_PATH);
        $Crypt3Des = new Crypt3Des();
        $no = $Crypt3Des->decrypt($no);
        */
        $ewm = model('Ewm')->getZyhByNo($no);
        $zhuyuanhao = $ewm['zhuyuanhao'];
        $patientInfo = model('Oracle')->getPatientinfo($zhuyuanhao);
        if(empty($patientInfo))
        {
            return output(['code'=>'02','msg'=>'住院患者不存在','data'=>[]]);
        }
        if(substr($ewm['addtime'],0,10) != date('Y-m-d'))
        {
            return output(['code'=>'12','msg'=>'此二维码已失效','data'=>[]]);
        }
        $authority = model('Authority');
        $result = $authority->saoma($no,$zhuyuanhao,$mid,1);
        if($result == 'Exit Error')
        {
             return output(['code'=>'09','msg'=>'出闸机发生错误','data'=>[]]);
        }
        return output(['code'=>'00','msg'=>'允许出','data'=>[]]);
    }
    //心跳包
    public function heartbeat($id,$ip)
    {
        $res = model('Authority')->updateDev($id,$ip);
        return output(['code'=>'FF','msg'=>'success','data'=>['one_open'=>':'.$res]]);
    }
    //看日志
    public function workmanlog($date = '')
    {
        if($date == '')
            $date = date('Y-m-d');
        $file = LOG_PATH.'workman_'.$date.'.log';
        if(file_exists($file))
            echo str_replace("\r\n","<br>",file_get_contents($file));
    }
    //测试
    public function test($no,$s = 'in')
    {   
         
         $patientInfo = model('Oracle')->getPatientinfo('633537');
         $rules = model('Authority')->getAuthRule($patientInfo,['shenfenzheng'=>'']);
         print_r($patientInfo);
         print_r($rules);exit;
         
        if($s == 'in')
            $output = $this->saomain($no,'0001');
        else if($s == 'out') 
            $output = $this->saomaout($no,'0001');

         var_dump($output);exit;
    }
    //找测试住院号
    public function testZhuyuanhao()
    {
        $today = date('Y-m-d');
        $yesterday = date('Y-m-d', strtotime('-1 day'));
        $jcday = date('Y-m-d',strtotime('-2 day'));
        $limit = 3;

        $sql['in'] = "select ZHUYUANHAO from view_rwzb_patientinfo where IN_TIME is not null and TO_CHAR(IN_TIME,'YYYY-MM-DD')='$today' and rownum<=$limit";
        $sql['zqss'] = "select ZHUYUANHAO from view_rwzb_patientinfo where YN_SHOUSHU='是' and SHOUSHURQ is not null and TO_CHAR(SHOUSHURQ,'YYYY-MM-DD') >='$yesterday' and rownum<=$limit";
        $sql['icu'] = "select ZHUYUANHAO from view_rwzb_patientinfo where YN_ICU='是' and rownum<=$limit";
        $sql['out'] = "select distinct ZHUYUANHAO from view_rwzb_ipm where ITEMNAME='出院通知' and TO_CHAR(USETIME,'YYYY-MM-DD')='$today' and rownum<=$limit";
        $sql['pz'] = "select distinct ZHUYUANHAO  from view_rwzb_ipm where ITEMNAME='留陪一人' and rownum<=$limit";
        $sql['jc'] = "select distinct ZHUYUANHAO from view_rwzb_ipm where YN_JC=1 and TO_CHAR(USETIME,'YYYY-MM-DD')>='$jcday' and rownum<=$limit";
        $sql['ssyz'] = "select distinct ZHUYUANHAO  from view_rwzb_ipm where (ITEMNAME='备皮（住院）' OR ITEMNAME LIKE '%造影%' OR ITEMNAME LIKE '%介入治疗%') and TO_CHAR(USETIME,'YYYY-MM-DD')>='$yesterday' and rownum<=$limit";

        $kv = array(
            'in'=>'入院',
            'out'=>'出院',
            'icu'=>'重症',
            'pz'=>'陪住',
            'jc'=>'检查',
            'zqss'=>'择期手术',
            'ssyz'=>'手术医嘱'
        );
        $rows = model('Oracle')->getsql($sql);
        $str = '';
        foreach ($rows as $key => $value) {
            $str .= $kv[$key].':';
            foreach ($value as $v) {
                $str .= $v['ZHUYUANHAO'].',';
            }
            $str .= "\r\n";
        }
        file_put_contents('testZhuyuanhao.txt', $str);
    }
    //处理权限
    private function manRule($zhuyuanhao,$rules)
    {
        if(empty($rules))
        {
            return [];
        }
        /**
         * a.陪住或外出检查权限优先级最高并且不累加
         * b.患者自身权限和病区权限累加
         */
        $rule = [];
        $rule_d = [];
        $rule_b = [];
        $rule_s = [];
        //转换成json
        if($rules['d'])
        {
            $rule_d = json_decode($rules['d'],true);
        }
        if($rules['b'])
        {
            $rule_b = json_decode($rules['b'],true);
        }
        if($rules['s'])
        {
            $rule_s = json_decode($rules['s'],true);
        }
        if(count($rule_d) > 0)//陪住或外出检查权限
        {
            $rule = $rule_d;
        }
        else
        {
            if(count($rule_s) > 0)
                $rule = array_merge($rule,$rule_s);
            if(count($rule_b) > 0)
                $rule = array_merge($rule,$rule_b);
        }
        if(empty($rule))
        {
            return [];
        }
        //工作日对应结果为0, 休息日对应结果为1, 节假日对应的结果为2
        $holidays = config('holidays');
        $festive = $holidays[date('md')] ?? 0;
        $hi = date('H:i');
        $week = date('N');

        $nc = [];
        $key = $week.'_'.$hi;
        //权限合并
        $authority = model('Authority');
        foreach ($rule as $k=>$r) 
        {
            //星期和法定假日
            $weeks = explode(',',$r['week']);
            if(in_array($week,$weeks) || (end($weeks) == 8 && $festive > 0))
            {
                $rule[$k]['in_num'] = 0;
                list($st,$et) = explode('-',$r['time']);
                 //不限制给86400
                if($r['number'] === '')
                    $rule[$k]['number'] = '';
                if($r['cishu'] === '')
                    $rule[$k]['cishu'] = '';  
                if($hi >= $et)
                {
                    unset($rule[$k]);
                }
                else if($hi >= $st && $hi <= $et)
                {
                    //人数，现在调整从总人数到同时进入病区的人数
                    $inout_n = $authority->getInout([
                        'a'=>'r',
                        'zhuyuanhao'=>$zhuyuanhao,
                        'no'=>'',
                        'st'=>$st,
                        'et'=>$et
                    ]);
                    $rule[$k]['in_num'] = $inout_n;
                }
            }
            else
            {
                unset($rule[$k]);
            }
        }
        return $rule;
    }
}
