<?php
namespace app\push\controller;
use think\worker\Server;
use app\frontend\controller\Index;
class Worker extends Server
{
    protected $socket;

    public function __construct()
    {
        $this->socket = config('socketServer');
        parent::__construct();
    }
    /**
     * 收到信息
     * @param $connection
     * @param $data
     */ 
    public function onMessage($connection, $data)
    {
        $data_log = $data;
        $data = json_decode($data,true);
        $Index = new Index();

        //日志不记录心跳包
        
        if($data['action'] != 'heartbeat')
        {
            file_put_contents(LOG_PATH.'workman_'.date('Y-m-d').'.log',
            'time:'.date('H:i:s').',receive:'.$data_log."\r\n",FILE_APPEND);
        }
        
	    $action_pre = $data['action'];
        $inoutDevids = config('r_inout_devids');
        if(!empty($inoutDevids) && in_array($data['id'],explode(',',$inoutDevids)))
        {
            if($data['action'] == 'saomain')
                $data['action'] = 'saomaout';
            elseif($data['action'] == 'saomaout')
                $data['action'] = 'saomain';
        }
        if($data['action'] == 'saomain')
        {
            $return = $Index->saomain($data['param'],$data['id']);
        }
        elseif($data['action'] == 'saomaout')
        {
            $return = $Index->saomaout($data['param'],$data['id']);
        }
        elseif($data['action'] == 'heartbeat')
        {
            $return = $Index->heartbeat($data['id'],$connection->getRemoteIp());
        }
        else
        {
            $return = ['code'=>'11','msg'=>'action参数不能为空','data'=>[]];
        }
        $return['action'] = $action_pre;
        //日志不记录心跳包
        
        if($data['action'] != 'heartbeat')
        {
            file_put_contents(LOG_PATH.'workman_'.date('Y-m-d').'.log',
             'time:'.date('H:i:s').',return:'.json_encode($return).var_export($return,true)."\r\n",FILE_APPEND);
        }
        $connection->send(json_encode($return));
        if($data['action'] == 'saomain' || $data['action'] == 'saomaout')
        {
            usleep(200000);//100毫秒
            $connection->send(json_encode($return));
        }
    }

    /**
     * 当连接建立时触发的回调函数
     * @param $connection
     */
    public function onConnect($connection)
    {
        $connection->send('connect');
    }

    /**
     * 当连接断开时触发的回调函数
     * @param $connection
     */
    public function onClose($connection)
    {
        $connection->send('close');
    }

    /**
     * 当客户端的连接上发生错误时触发
     * @param $connection
     * @param $code
     * @param $msg
     */
    public function onError($connection, $code, $msg)
    {
        $connection->send('error');
    }

    /**
     * 每个进程启动
     * @param $worker
     */
    public function onWorkerStart($worker)
    {

    }
}
