<?php
class AuthorityAction extends CommonAction
{
	/**
     * @desc 权限列表
     * @fina 2019-05-20
     */
	public function index()
	{
		$Authority = M("Authority");
		if($_GET['name'])
		$map['name'] = array('like', "%{$_GET['name']}%");

		if($_GET['from'] == 'unit')	
		{
			$filter = $this->user_filter();
			if($filter) 
			{
				$filter['is_sys'] = 1;
				$filter['_logic'] = 'or';
				$map['_complex'] = $filter;
			}
			$list = $Authority->where($map)->field('id,name,is_sys')->order('id desc')->findAll();
			$Object_authority = M("Object_authority");
			$authority_id = $Object_authority->where('object_id='.$_GET['bingqucode'].' and type=2')->getField('authority_id');
			$this->assign('list',$list);
			$this->assign('authority_id',$authority_id);
			$this->display('select');	
			exit;
		}
		import("ORG.Page");
		$map = array();
		$map['id'] = array('not in',array(7));
		$filter = $this->user_filter();
		if($filter) 
		{
			$filter['is_sys'] = 1;
			$filter['_logic'] = 'or';
			$map['_complex'] = $filter;
		}
		$count = $Authority->where($map)->count();
		$p = new Page($count,C('DATA_PAGE'));
		$list = $Authority->where($map)->limit($p->firstRow.','.$p->listRows)->findAll();
		$week = array(
			1 => '周一',
			2 => '周二',
			3 => '周三',
			4 => '周四',
			5 => '周五',
			6 => '周六',
			7 => '周日',
			8 => '法定假日',
		);
		foreach($list as &$l)
		{
			$rule = json_decode($l['rule'],true);
			$str = '';
			foreach($rule as $r)
			{
				$r['week'] = explode(',',$r['week']);
				$r['week'] = array_flip($r['week']);
				foreach($week as $wk=>$wv)
				{
					if(isset($r['week'][$wk]))
						$str .= $wv.'√';
					else
						$str .= $wv.'×';
				}
				$str .= '<br>时间:'.$r['time'];
				$str .= ',人数:';
				if($r['number'] == '')
					$str .= '不限';
				else
					$str .= $r['number'];
				$str .= ',次数:';
				if($r['cishu'] == '')
					$str .= '不限';
				else
					$str .= $r['cishu'];
				$str .="<br>";
			}
			$l['rule'] = $str;
			if($l['is_sys'] == 1)
				$l['is_sys_text'] = '系统内置';
			else
				$l['is_sys_text'] = '用户自定义';
		}
		$p->setConfig('prev',"上一页");
		$p->setConfig('next',"下一页");
		$p->setConfig('first',"首页");
		$p->setConfig('last',"尾页");
		$page = $p->show();

		$this->assign('page',$page);
		$this->assign('list',$list);
		$this->assign('filter', $_GET);
		$this->display();
	}

	/**
     * @desc 添加权限动作
     * @final 2019-04-13
     */
	public function insert()
	{
		if($_POST['from'] == 'patient')
		{
			$list = false;
			if($_POST['zhuyuanhao'])
			{
				$zhuan = explode(',',$_POST['zhuyuanhao']);
				$Patient_authority = M('Patient_authority');

				$pa_data = array();
				$pa_data['b_auth'] = $_POST['b_auth'];
				$doRule = $this->doRule();
				if($doRule)
				{
					$pa_data['rule'] = $doRule;
				}

				foreach ($zhuan as $z)
				{
					if(!$Patient_authority->where(array('zhuyuanhao'=>$z))->field('id')->find())
					{
						$this->addPatientAut($Patient_authority,$z);
					}
				}
				$list = $Patient_authority->where(array('zhuyuanhao'=>array('in',$zhuan)))->save($pa_data);
			}
			$this->_writelog('住院患者增加权限[住院号:'.$_POST['zhuyuanhao'].']',$list);
			if($list !== false)
			{
				echo "<script type='text/javascript'>parent.complete('".urlencode('增加权限成功')."',1)</script>";
			}else{
				echo "<script type='text/javascript'>parent.complete('".urlencode('增加权限失败！')."',0)</script>";
			}
			exit;	
		}
		$Authority = D("Authority");
		if($vo = $Authority->create())
		{
			$doRule = $this->doRule();
			if($doRule)
			{
				$Authority->rule = $doRule;
			}
			$Authority->user_id = $_SESSION[C('USER_AUTH_KEY')];
			$list = $Authority->add();
			$this->_writelog('添加权限[ID:'.$list.'名称:'.$_POST['name'].']',$list);
			if($list !== false)
			{
				echo "<script type='text/javascript'>parent.complete('".urlencode('添加权限成功,正在跳转...')."',1)</script>";
			}else{
				echo "<script type='text/javascript'>parent.complete('".urlencode('添加权限失败！')."',0)</script>";
			}
		}else
		{
			echo "<script type='text/javascript'>parent.complete('".urlencode($Authority->getError())."',0)</script>";
		}
	}


	/**
     * @desc 更新权限动作
     * @fina 2019-02-25
     */
	public function update()
	{
		$Authority = D("Authority");
		if($vo = $Authority->create())
		{
			$Authority->rule = $this->doRule();
			$list=$Authority->save();
			$this->_writelog('更新权限ID:'.$_POST['id'].'名称:'.$_POST['name'].']',$list);
			if($list!==false)
			{
				echo "<script type='text/javascript'>parent.complete('".urlencode('更新权限成功,正在跳转...！')."',1)</script>";
			}else
			{
				echo "<script type='text/javascript'>parent.complete('".urlencode('更新权限信息失败！')."',0)</script>";
			}
		}else
		{
			echo "<script type='text/javascript'>parent.complete('".urlencode($Authority->getError())."',0)</script>";
		}
	}
	/**
	 *处理规则
	 */
	private function doRule()
	{
		$week = $_POST['week'];
		$st = $_POST['st'];
		$et = $_POST['et'];
		$number = $_POST['number'];
		$cishu = $_POST['cishu'];

		$json = array();
		foreach($week as $k=>$w)
		{
			$n =$k+1;
			if(empty($w))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('请选择第'.$n.'条规则的周期')."',0)</script>");
			}
			$w = implode(',',$w);
			if(!preg_match('/^([1-8],?){1,}$/',$w))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的周期格式不正确')."',0)</script>");
			}
			if(empty($st[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('请选择第'.$n.'条规则的开始时间')."',0)</script>");
			}
			if(empty($et[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('请选择第'.$n.'条规则的结束时间')."',0)</script>");
			}
			if($et[$k] <= $st[$k])
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的结束时间必须大于开始时间')."',0)</script>");
			}
			if(!preg_match('/^\d{2}:\d{2}$/',$st[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的开始时间格式不正确')."',0)</script>");
			}
			if(!preg_match('/^\d{2}:\d{2}$/',$et[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的结束时间格式不正确')."',0)</script>");
			}
			/*
			if(empty($number[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('请输入第'.$n.'条规则的人数')."',0)</script>");
			}
			if(empty($cishu[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('请输入第'.$n.'条规则的次数')."',0)</script>");
			}
			*/
			if($number[$k] && !preg_match('/^\d+$/',$number[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的人数格式不正确')."',0)</script>");
			}
			if($cishu[$k] && !preg_match('/^\d+$/',$cishu[$k]))
			{
				exit("<script type='text/javascript'>parent.complete('".urlencode('第'.$n.'条规则的次数格式不正确')."',0)</script>");
			}
			$json[$k]['week'] = $w;
			$json[$k]['time'] = $st[$k].'-'.$et[$k];
			$json[$k]['number'] = $number[$k];
			$json[$k]['cishu'] = $cishu[$k];
		}
		return json_encode($json);
	}
	/**
     * @desc 删除权限动作
     * @fina 2019-04-13
     */
	public function delete()
	{
		if($_GET['id'])
		{
			$Authority = M("Authority");
			$Object_authority = D("Object_authority");
			$map['id'] = $_GET['id'];
			$map['is_sys'] = 0;
			$filter = $this->user_filter();
			if($filter) $map = array_merge($map,$filter);
			$result = $Authority->where($map)->delete();
			$this->_writelog('删除权限[ID:'.$_GET['id'].']',$result);
			if(false !== $result)
			{
				$Object_authority->where('authority_id',$_GET['id'])->delete();
				$this->success('删除权限成功！');
			}else
			{
				$this->error('删除权限失败！');
			}
		}else{
			$Authority = M("Authority");
			$Object_authority = D("Object_authority");
			if($_POST['deletesel'] == 'selected')
			{
				$condition['id'] = array('in',$_POST['id']);
				$condition['is_sys'] = 0;
				$filter = $this->user_filter();
				if($filter) $condition = array_merge($condition,$filter);
				$ids = implode( ',', $_POST['id']);
				$result = $Authority->where($condition)->delete();
			}
			else 
			{
				if($_POST['name'])
					$map['name'] = array('like', "{$_POST['name']}%");
				$map['is_sys'] = 0;
				$filter = $this->user_filter();
				if($filter) $map = array_merge($map,$filter);
				$id= $Authority->where($map)->field('id')->findall();
				if(empty($id)) $this->error('没有记录');
				$result = $Authority->where($map)->delete();
				$ids = array();
				foreach ($id as $v)
				{
					$ids[] = $v['id'];
				}
				$ids = join(',', $ids);
			}
			$this->_writelog('删除权限[ID:'.$ids.']',$result);
			if(false !== $result)
			{
				$Object_authority->where("authority_id in($ids)")->delete();
				$this->success('删除权限成功！');
			}else
			{
				$this->error('删除权限失败！');
			}
		}
	}

	/**
     * @desc 编辑和添加权限
     * @fina 2019-04-13
     */
	public function edit()
	{
		if($_GET['from'] == 'patient')
		{
			if(substr($_GET['zhuyuanhao'], ','))//批量	
			{
				$vo = array();
				$vo['id'] = 0;
				$vo['rule'] = '';
			}
			else
			{
				$vo = M('Patient_authority')->where("zhuyuanhao='{$_GET['zhuyuanhao']}'")->field('rule,b_auth')->find();
				$vo['rule'] = json_decode($vo['rule'],true);
				if($vo['b_auth'] == '') $vo['b_auth'] = 0;
			}
			$this->assign('is_has_rule',$vo['rule'] ? 1 : '');
			$this->assign('vo',$vo);
		}
		else if(!empty($_GET['id']))
		{
			$Authority = M("Authority");
			$vo	= $Authority->find($_GET['id']);
			if($vo)
			{
				$vo['rule'] = json_decode($vo['rule'],true);
				$this->assign('vo',$vo);
			}else
			{
				$this->error("编辑项不存在！");
			}
		}
		$this->display('add');
	}
	/**
     * @desc 选择权限
     * @fina 2019-04-13
     */
	public function sel()
	{
		$Object_authority = D("Object_authority");

		$code = $_POST['code'];
		$authority_id = $_POST['authority_id'];

		if($code && $authority_id)
		{
			$row = $Object_authority->where('type=2 AND object_id='.$code)->find();
			$Object_authority->authority_id = $authority_id;
			if($row)
			{
				if($row['authority_id'] != $authority_id)
				{
					$Object_authority->id = $row['id'];
					$result = $Object_authority->save();
				}
				else
					$result = true;
			}
			else
			{
				$Object_authority->object_id = $code;
				$Object_authority->type = 2;
				$result = $Object_authority->add();
			}
			$this->_writelog('设置权限[病区CODE:'.$code.'权限ID:'.$authority_id.']',$result);
			if($result !== false)
			{
				$this->success('设置权限成功');
			}
			else
			{
				$this->error('设置权限失败');
			}
		}
		else
		{
			$this->error('参数不正确');
		}
	}
}

