<?php
class HospitalAction extends CommonAction
{
	/**
     * @desc 病区信息列表
     * @fina 2019-05-29
     */
	public function unit()
	{
		import ( '@.ORG.Oracle' );
		import("ORG.Page");

		$where = "BINGQU NOT LIKE '%(旧)'";
		if($_GET['bingqu'])
		{
			$where .= " AND BINGQU LIKE '%{$_GET['bingqu']}%'";
		}
		if($_GET['keshi'])
		{
			$where .= " AND KESHI LIKE '%{$_GET['keshi']}%'";
		}
		$where .= $this->bingqu_filter(0);
		if($where) $where = 'WHERE '.ltrim($where,' AND ');
		$db = new Oracle();
		$conn = $db->logon();
		$sql = "SELECT COUNT(*) AS TP_CNT FROM view_rwzb_unit {$where} ORDER BY BINGQUCODE";
		$count = $db->query($sql,$conn);
		$count = $count[0]['TP_CNT'];	

		$p = new Page($count,C('DATA_PAGE'));
		$sql = "SELECT * FROM view_rwzb_unit {$where}";
		$sql = "SELECT * FROM ( SELECT ROWNUM R_ROWNUM, r.* FROM ( $sql ) r WHERE ROWNUM <= $p->perRows ) WHERE R_ROWNUM >= $p->firstRow";
		$list = $db->query($sql,$conn);

		$p->setConfig('prev',"上一页");
		$p->setConfig('next',"下一页");
		$p->setConfig('first',"首页");
		$p->setConfig('last',"尾页");
		$page = $p->show();
		$this->assign('page',$page);
		$this->assign('list',$list);
		$this->display();
	}

	/**
     * @desc 住院患者列表
     * @fina 2019-05-29
     */
	public function patient()
	{
		import ( '@.ORG.Oracle' );
		import("ORG.Page");

		$where = '';
		if($_GET['bingqu'])
		{
			$where .= " AND BINGQU LIKE '%{$_GET['bingqu']}%'";
		}
		if($_GET['zhuyuanhao'])
		{
			$where .= " AND ZHUYUANHAO='{$_GET['zhuyuanhao']}'";
		}
		if($_GET['xds'])
		{
			$where .= " AND (PAT_NAME LIKE '{$_GET['xds']}%' OR SHENFENZHENG='{$_GET['xds']}' OR TELPHONE='{$_GET['xds']}')";
		}
		$_GET['status'] = isset($_GET['status']) ? $_GET['status'] : 0;
		if($_GET['status'] != null && $_GET['status'] != "")
		{
			$where.= " AND YNOUT={$_GET['status']}";
		}
		$where .= $this->bingqu_filter(0);
		if($where) $where = 'WHERE '.ltrim($where,' AND ');
		$db = new Oracle();
		$conn = $db->logon();
		$sql = "SELECT COUNT(*) AS TP_CNT FROM view_rwzb_patientinfo {$where} ORDER BY BINGQUCODE";
		$count = $db->query($sql,$conn);
		$count = $count[0]['TP_CNT'];	

		$p = new Page($count,C('DATA_PAGE'));
		$sql = "SELECT to_number(REGEXP_REPLACE(nvl(BEDNO,0),'[^' || UNISTR ('\\4E00') || '-' || UNISTR ('\9FA5') || '^0-9]','9')) as BEDNO_NEW,v.* FROM view_rwzb_patientinfo v {$where} ORDER BY ROOMNO,BEDNO_NEW";
		$sql = "SELECT * FROM ( SELECT ROWNUM R_ROWNUM, r.*, TO_CHAR(r.IN_TIME, 'yyyy-mm-dd') IN_TIME_YMD,TO_CHAR(r.OUTDATE, 'yyyy-mm-dd') OUTDATE_YMD,TO_CHAR(r.SHOUSHURQ, 'yyyy-mm-dd') SHOUSHURQ_YMD FROM ( $sql ) r WHERE ROWNUM <= $p->perRows ) WHERE R_ROWNUM >= $p->firstRow";
		$list = $db->query($sql,$conn);
		//查状态
		$zhuyuan = array();
		$intime = array();
		$outtime = array();
		$yn_shoushu_now = array();

		$sql = "select ITEMCODE from view_rwzb_item where ITEMNAME in('备皮（住院）')";
		$items = $db->query($sql,$conn);
		$items_str = '';
		foreach ($items as $k => $v) {
			$items_str .= "'{$v['ITEMCODE']}',";
		}
		$items_str = rtrim($items_str,',');
		$sskv = array();
		$zzkv = array();
		foreach($list as $lk=>$li)
		{
			$zhuyuan[] = $li['ZHUYUANHAO'];
			$intime[$li['ZHUYUANHAO']] = $li['IN_TIME_YMD'];
			$outtime[$li['ZHUYUANHAO']] = $li['OUTDATE_YMD'];

			if($li['YN_SHOUSHU'] == '是' && date('Y-m-d') >= date('Y-m-d',strtotime($li['SHOUSHURQ_YMD'])-86400))
				$sskv[$li['ZHUYUANHAO']] = 1;
			if($li['YN_ICU'] == '是')
				$zzkv[$li['ZHUYUANHAO']] = 1;
		}
		$sql = "select ZHUYUANHAO from view_rwzb_ipm where ZHUYUANHAO in('".implode("','",$zhuyuan)."') AND (ITEMCODE in($items_str) OR ITEMNAME LIKE '%造影%' OR ITEMNAME LIKE '%介入治疗%') AND TO_CHAR(USETIME,'YYYY-MM-DD')>='".date('Y-m-d',strtotime('-1 day'))."'";
		$ssrows = $db->query($sql,$conn);
		foreach ($ssrows as $ks => $vs) {
			$sskv[$vs['ZHUYUANHAO']] = 1;
		}

		$zhqx = array();
		$rulekv = array();
		if($zhuyuan)
		{
			$Authority = M("Authority");
			$arule = $Authority->field('id,rule')->where('is_sys=1')->select();
			$arule_kv = array();
			$week = array(
				1 => '周一',
				2 => '周二',
				3 => '周三',
				4 => '周四',
				5 => '周五',
				6 => '周六',
				7 => '周日',
				8 => '法定假日',
			);
			foreach($arule as $l)
			{

				$rule = json_decode($l['rule'],true);
				$str = '';
				foreach($rule as $r)
				{
					$r['week'] = explode(',',$r['week']);
					$r['week'] = array_flip($r['week']);
					foreach($week as $wk=>$wv)
					{
						if(isset($r['week'][$wk]))
							$str .= $wv.'√';
						else
							$str .= $wv.'×';
					}
					$str .= "\r\n时间:".$r['time'];
					$str .= ',人数:';
					if($r['number'] == '')
						$str .= '不限';
					else
						$str .= $r['number'];
					$str .= ',次数:';
					if($r['cishu'] == '')
						$str .= '不限';
					else
						$str .= $r['cishu'];
					$str .="\r\n";
				}
				$arule_kv[$l['id']] = $str;
			}
			unset($arule);

			$Patient_authority = M('Patient_authority');
			$pa = $Patient_authority->where(array('zhuyuanhao'=>array('in',$zhuyuan)))->select();
			foreach ($pa as $pa_row) {
				$rulekv[$pa_row['zhuyuanhao']] = $pa_row['rule'];
				if($intime[$pa_row['zhuyuanhao']] == date('Y-m-d'))
					$zhqx[$pa_row['zhuyuanhao']][] = array('今日入住-超级权限',$arule_kv[2]);
				else if(!empty($outtime[$pa_row['zhuyuanhao']]) && $outtime[$pa_row['zhuyuanhao']] > date('Y-m-d',strtotime('-2 day')))
					$zhqx[$pa_row['zhuyuanhao']][] = array('出院权限(近两天有效)',$arule_kv[8]);
				else if($pa_row['is_operation'] == 1)
					$zhqx[$pa_row['zhuyuanhao']][] = array('手术权限',$arule_kv[3]);
				else if($pa_row['is_icu'] == 1)
					$zhqx[$pa_row['zhuyuanhao']][] = array('重症监护室权限',$arule_kv[6]);
				else if($pa_row['is_jc'] == 1)
					$zhqx[$pa_row['zhuyuanhao']][] = array('陪同患者外出检查权限(近三天有效)',$arule_kv[4]);
				else if($pa_row['is_pz'] == 1)
					$zhqx[$pa_row['zhuyuanhao']][] = array('陪住家属权限',$arule_kv[5]);
				else
					$zhqx[$pa_row['zhuyuanhao']][] = array('',$arule_kv[1]);
			}
		}
		$p->setConfig('prev',"上一页");
		$p->setConfig('next',"下一页");
		$p->setConfig('first',"首页");
		$p->setConfig('last',"尾页");
		$page = $p->show();
		$this->assign('zhqx',$zhqx);
		$this->assign('rulekv',$rulekv);
		$this->assign('sskv',$sskv);
		$this->assign('zzkv',$zzkv);
		$this->assign('arule_kv',$arule_kv);
		$this->assign('zhqx',$zhqx);
		$this->assign('page',$page);
		$this->assign('list',$list);
		$this->display();
	}
	/**
     * @desc 家属列表
     * @fina 2019-05-29
     */
	public function set()
	{
		$map = array();
		$map['zhuyuanhao'] = $_GET['zhuyuanhao'];
		if($_GET['shenfenzheng'])
			$map['shenfenzheng'] = $_GET['shenfenzheng'];

		$Dependents = M("Dependents");
		$list = $Dependents->where($map)->findAll();

		$Patient_authority = M("Patient_authority");
		$pa = $Patient_authority->where("zhuyuanhao={$_GET['zhuyuanhao']}")->field('pz_status,jc_status')->find();
		$ids = array();
		$obIds = array();
		if($_GET['type'] == 1)
		{
			$status = $pa['pz_status'];
			$authority_id = 5;
		}
		if($_GET['type'] == 2)
		{
			$status = $pa['jc_status'];
			$authority_id = 4;
		}
		if($list)
		{
			foreach ($list as $l) {
				$ids[] = $l['id'];
			}
			$Object_authority = M("Object_authority");
			$oaRow = $Object_authority->where(array(
				'object_id'=>array('in',$ids),
				'authority_id'=>$authority_id,
				'type'=>3,
				))->field('object_id')->select();
			foreach ($oaRow as $ow) {
				$obIds[$ow['object_id']] = 1;
			}
		}

		$this->assign('status',$status);
		$this->assign('list',$list);
		$this->assign('obids',$obIds);
		$this->display();
	}
	/**
     * @desc 设置家属权限
     * @fina 2019-05-29
     */
	public function setajax()
	{
		$ids = $_POST['id'];
		$type = $_POST['type'];
		$zhuyuanhao = $_POST['zhuyuanhao'];
		if(empty($type) || empty($zhuyuanhao))
		{
			$this->error("参数错误");	
		}

		$Object_authority = D("Object_authority");
		$Object_authority->startTrans();
		try{
			if($type == 1)
			{
				$authority_id = 5;
				$pa_data['pz_status'] = $_POST['status'];
			}
			elseif($type == 2)
			{
				$authority_id = 4;
				$pa_data['jc_status'] = $_POST['status'];
			}
			//删除之前的权限
			$rows = M("Dependents")->where("zhuyuanhao='$zhuyuanhao'")->field('id')->select();
			if($rows)
			{
				foreach($rows as $r) {
					$ids_[] = $r['id'];
				}
				$map['object_id'] = array('in',$ids_);
				$map['authority_id'] = $authority_id;
				$map['type'] = 3;
				$Object_authority->where($map)->delete();
			}
			if($ids != '')
			{
				$oaData = array();
				if($type == 1)
				{
					$title = "陪住";
					$oaData[0]['authority_id'] = $authority_id;
					$ids = explode(',',$ids);
					$oaData[0]['object_id'] = $ids[0];
					$oaData[0]['type'] = 3;
				}
				elseif($type == 2)
				{
					$title == "陪同外出检查";
					$ids = explode(',',$ids);
					$n = 0;//最多两名家属
					foreach($ids as $k=>$id)
					{
						if($n > 1) break;
						if($id)
						{
							$oaData[$k]['authority_id'] = $authority_id;
							$oaData[$k]['object_id'] = $id;
							$oaData[$k]['type'] = 3;
							$n++;
						}
					}
				}
				//增加新的权限
				$Object_authority->addAll($oaData);
			}
			//启用停用
			M("Patient_authority")->where("zhuyuanhao=$zhuyuanhao")->save($pa_data);

			$result = true;
		}catch(Exception $e){
			$result = false;
		}
		$this->_writelog('设置'.$title.'权限[住院号:'.$zhuyuanhao.']',$result);
		if($result)
		{
			$Object_authority->commit();
			$this->success("设置".$title."权限成功");
		}
		else
		{
			$Object_authority->rollback();
			$this->error("设置".$title."权限失败");
		}
	}
	/**
     * @desc 新增家属
     * @fina 2019-05-29
     */
	public function dep()
	{
		$this->display();
	}
	/*
     * @desc 新增家属
     * @fina 2019-06-10
     */
    public function depajax()
    {
        $role = D("Dependents");
        if($vo = $role->create()) {
        	$one = $role->where("zhuyuanhao='{$_POST['zhuyuanhao']}' AND shenfenzheng='{$_POST['shenfenzheng']}'")->field('id')->find();
        	if($one)
        	{
                exit("<script type='text/javascript'>parent.complete('".urlencode('此家属已存在')."',".$list.")</script>");
        	}
            $list=$role->add();
            $this->_writelog('添加家属:'.$_POST['shenfenzheng'],$list);
            if($list!==false){
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加家属成功')."',".$list.")</script>";
            }
            else
            {
                echo "<script type='text/javascript'>parent.complete('".urlencode('添加家属失败！')."',0)</script>";
            }
        }
        else
        {
            echo "<script type='text/javascript'>parent.complete('".urlencode($role->getError())."',0)</script>";
        }
    }
    /**
     * @desc 删除家属权限
     * @fina 2019-05-29
     */
	public function depdelajax()
	{
		$id = $_POST['id'];
		$type = $_POST['type'];
		$zhuyuanhao = $_POST['zhuyuanhao'];
		if(empty($type) || empty($zhuyuanhao))
		{
			$this->error("参数错误");	
		}

		$Object_authority = D("Object_authority");
		$Object_authority->startTrans();
		try{
			//删除之前的权限
			M("Dependents")->where("id=$id")->delete();
			$Object_authority->where("object_id=$id AND type=3")->delete();
			$result = true;
		}catch(Exception $e){
			$result = false;
		}
		$this->_writelog('删除家属[ID:'.$id.']',$result);
		if($result)
		{
			$Object_authority->commit();
			$this->success("删除家属成功");
		}
		else
		{
			$Object_authority->rollback();
			$this->error("删除家属失败");
		}
	}
	/**
     * @desc 其他权限
     * @fina 2019-05-29
     */
	public function otherset()
	{
		$map = array();
		$map['zhuyuanhao'] = $_GET['zhuyuanhao'];

		$Patient_authority = M("Patient_authority");
		$vo = $Patient_authority->where($map)->field('is_die,die_date,is_operation,operaton_date,is_operation_j,operation_j_date')->find(); 
		$this->assign('vo',$vo);
		$this->display();
	}
	/**
     * @desc 其他权限设置ajax
     * @fina 2019-05-29
     */
	public function othersetajax()
	{
		$zhuyuanhao = $_POST['zhuyuanhao'];
		if(empty($zhuyuanhao))
		{
			 exit("<script type='text/javascript'>parent.complete('".urlencode('参数错误')."',0)</script>");
		}
		$Patient_authority = M("Patient_authority");

		$vo = $Patient_authority->where("zhuyuanhao='$zhuyuanhao'")->field('is_die,is_operation,is_operation_j')->find();
		if(empty($vo))
		{
			$this->addPatientAut($Patient_authority,$zhuyuanhao);	
		}
		if($_POST['is_die'] == 1 && empty($_POST['die_date']))
		{
			 exit("<script type='text/javascript'>parent.complete('".urlencode('请输入死亡日期')."',0)</script>");
		}
		if($vo['is_operation'] == 1 && $_POST['is_operation'] == 0 && empty($_POST['operation_date']))
		{
			 exit("<script type='text/javascript'>parent.complete('".urlencode('请输入手术室结束日期')."',0)</script>");
		}
		if($_POST['is_operation_j'] == 2 && empty($_POST['operation_j_date']))
		{
			 exit("<script type='text/javascript'>parent.complete('".urlencode('请输入急诊手术结束日期')."',0)</script>");
		}

		$sdata = array();

		//急诊手术权限处理,改为手术权限
		if($_POST['is_operation_j'] == 1)
		{
			$sdata['rule'] = M('Authority')->where('id=6')->getField('rule');
		}
		//转入手术室
		if($_POST['is_operation'] == 1)
		{
			$sdata['rule'] = M('Authority')->where('id=6')->getField('rule');
			//普通探视取消	
			$sdata['b_auth'] = 1;
			//陪住权限取消
			$sdata['pz_status'] = 0;
			$sdata['jc_status'] = 0;
			//M('object_authority')->query("delete o from gate_object_authority o,gate_dependents d where o.object_id=d.id and type=3 and zhuyuanhao='$zhuyuanhao'");
		}
		//转出手术室
		if($vo['is_operation'] == 1 && $_POST['is_operation'] == 0)
		{
			//恢复普通权限
			$sdata['rule'] = '';
			$sdata['b_auth'] = 0;
		}

		$sdata['is_die'] = $_POST['is_die'];
		$sdata['die_date'] = $_POST['die_date'];
		$sdata['is_operation'] = $_POST['is_operation'];
		$sdata['operation_date'] = $_POST['operation_date'];
		$sdata['is_operation_j'] = $_POST['is_operation_j'];
		$sdata['operation_j_date'] = $_POST['operation_j_date'];
		$result = $Patient_authority->where("zhuyuanhao='$zhuyuanhao'")->save($sdata);

		$this->_writelog('其他设置[住院号:'.$zhuyuanhao.']',$result);
		if($result)
		{
			echo "<script type='text/javascript'>parent.complete('".urlencode('操作成功')."',1)</script>";
		}
		else
		{
			echo "<script type='text/javascript'>parent.complete('".urlencode('操作失败')."',0)</script>";
		}
	}
}
