/*
Navicat MySQL Data Transfer

Source Server         : localhost
Source Server Version : 50554
Source Host           : localhost:3306
Source Database       : gatedb

Target Server Type    : MYSQL
Target Server Version : 50554
File Encoding         : 65001

Date: 2019-06-17 14:04:55
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for gate_config
-- ----------------------------
DROP TABLE IF EXISTS `gate_config`;
CREATE TABLE `gate_config` (
  `key` varchar(16) NOT NULL,
  `value` varchar(32) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_config
-- ----------------------------
INSERT INTO `gate_config` VALUES ('ONE_OPEN', '0');
-- ----------------------------
-- Table structure for gate_access
-- ----------------------------
DROP TABLE IF EXISTS `gate_access`;
CREATE TABLE `gate_access` (
  `role_id` smallint(6) unsigned NOT NULL,
  `node_id` smallint(6) unsigned NOT NULL,
  `level` tinyint(1) NOT NULL,
  `module` varchar(50) DEFAULT NULL,
  KEY `groupId` (`role_id`),
  KEY `nodeId` (`node_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_access
-- ----------------------------

-- ----------------------------
-- Table structure for gate_authority
-- ----------------------------
DROP TABLE IF EXISTS `gate_authority`;
CREATE TABLE `gate_authority` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `name` varchar(128) NOT NULL COMMENT '权限名称',
  `rule` text NOT NULL COMMENT '时间人数规则格式json[{"11:30","12:30","1"},...]',
  `is_sys` tinyint(1) DEFAULT '0' COMMENT '是否是系统内置权限1是,0否',
  `user_id` int(1) DEFAULT '0' COMMENT '属主',
  `remark` varchar(500) DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='闸机权限表';

-- ----------------------------
-- Records of gate_authority
-- ----------------------------
INSERT INTO `gate_authority` VALUES ('1', '普通权限', '[{\"week\":\"1,2,3,4,5\",\"time\":\"11:30-13:59\",\"number\":\"1\",\"cishu\":\"4\"},{\"week\":\"1,2,3,4,5\",\"time\":\"13:30-19:30\",\"number\":\"2\",\"cishu\":\"1\"},{\"week\":\"6,7,8\",\"time\":\"11:30-12:30\",\"number\":\"1\",\"cishu\":\"1\"},{\"week\":\"6,7,8\",\"time\":\"13:30-19:30\",\"number\":\"2\",\"cishu\":\"1\"}]', '1', '            <ul>\r\n            <li>\r\n            1.周一至周五,11:30am-12:30pm（限定一人探视,15:00pm-19:00pm（限定二人探视)</li>\r\n            <li>2.周六、周日、法定节假日,11:30am-12:30pm（限定一人探视）,14:30pm-20:00pm（限定二人探视)</li>\r\n            </ul>');
INSERT INTO `gate_authority` VALUES ('2', '超级权限', '[{\"week\":\"1,2,3,4,5,6,7,8\",\"time\":\"00:00-23:59\",\"number\":\"\",\"cishu\":\"\"}]', '1', '不限时间,不限人数');
INSERT INTO `gate_authority` VALUES ('3', '手术权限', '[{\"week\":\"1,2,3,4,5,6,7\",\"time\":\"00:00-23:59\",\"number\":\"3\",\"cishu\":\"5\"}]', '1', '限定3人，每位家属限定5次进出次数，同时开启手术等待区域门禁权限；术后次日“零”点系统自动变更为普通探视；');
INSERT INTO `gate_authority` VALUES ('4', '陪同患者外出检查权限', '[{\"week\":\"1,2,3,4,5,6,7\",\"time\":\"00:00-23:59\",\"cishu\":\"5\",\"number\":\"\"}]', '1', '限定2人，每位家属限定5次进出次数；检查后次日“零”点系统自动变更为普通探视。');
INSERT INTO `gate_authority` VALUES ('5', '陪住家属权限', '[{\"week\":\"1,2,3,4,5,6,7\",\"time\":\"00:00-23:59\",\"cishu\":\"5\",\"number\":\"\"}]', '1', '限定1人，每日进出次数5次闸机，如遇特殊情况则按特殊权限流程处理； ');
INSERT INTO `gate_authority` VALUES ('6', '重症监护室权限', '[{\"week\":\"1,2,3,4,5,6,7\",\"time\":\"00:00-23:59\",\"number\":\"3\",\"cishu\":\"5\"}]', '1', '探视时间由重症监护室在系统中设定时间范围、家属数量');
INSERT INTO `gate_authority` VALUES ('7', '无任何权限', '[{}]', '1', '没有任何权限');
INSERT INTO `gate_authority` VALUES ('8', '特殊权限', '[{\"week\":\"1,2,3,4,5,6,7,8\",\"time\":\"00:00-23:59\",\"number\":\"100\",\"cishu\":\"100\"}]', '1', '对应HIS系统里探视设置');
-- ----------------------------
-- Table structure for gate_dependents
-- ----------------------------
DROP TABLE IF EXISTS `gate_dependents`;
CREATE TABLE `gate_dependents` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `zhuyuanhao` varchar(12) NOT NULL COMMENT '住院号',
  `shenfenzheng` char(18) DEFAULT NULL COMMENT '身份证号',
  `name` varchar(16) DEFAULT NULL COMMENT '姓名',
  `mobile` char(11) DEFAULT NULL COMMENT '手机号码',
  PRIMARY KEY (`id`),
  KEY `i_zhuyuanhao` (`zhuyuanhao`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='患者-家属表';

-- ----------------------------
-- Records of gate_dependents
-- ----------------------------

-- ----------------------------
-- Table structure for gate_dev
-- ----------------------------
DROP TABLE IF EXISTS `gate_dev`;
CREATE TABLE `gate_dev` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `direction` tinyint(1) NOT NULL DEFAULT '0' COMMENT '方向',
  `code` char(4) NOT NULL COMMENT '编号',
  `ip` bigint(11) NOT NULL COMMENT 'IP地址',
  `position` varchar(50) DEFAULT NULL COMMENT '位置',
  `active_time` int(11) NOT NULL COMMENT '活跃时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='闸机设备表';

-- ----------------------------
-- Records of gate_dev
-- ----------------------------

-- ----------------------------
-- Table structure for gate_logs
-- ----------------------------
DROP TABLE IF EXISTS `gate_logs`;
CREATE TABLE `gate_logs` (
  `id` int(12) NOT NULL AUTO_INCREMENT,
  `uid` int(5) NOT NULL,
  `action` varchar(256) DEFAULT NULL,
  `result` tinyint(1) DEFAULT NULL,
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_logs
-- ----------------------------

-- ----------------------------
-- Table structure for gate_node
-- ----------------------------
DROP TABLE IF EXISTS `gate_node`;
CREATE TABLE `gate_node` (
  `id` smallint(6) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `title` varchar(50) DEFAULT NULL,
  `status` tinyint(1) DEFAULT '0',
  `sort` smallint(6) unsigned DEFAULT NULL,
  `pid` smallint(6) unsigned NOT NULL,
  `level` tinyint(1) unsigned NOT NULL,
  `menu` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `level` (`level`),
  KEY `pid` (`pid`),
  KEY `status` (`status`),
  KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_node
-- ----------------------------
INSERT INTO `gate_node` VALUES ('1', 'sys', '系统管理', '1', '5', '0', '1', '0');
INSERT INTO `gate_node` VALUES ('2', 'sys', '系统管理', '1', '1', '1', '2', '0');
INSERT INTO `gate_node` VALUES ('3', 'log', '操作日志', '1', '1', '2', '3', '0');
INSERT INTO `gate_node` VALUES ('4', 'password', '修改密码', '1', '1', '2', '3', '0');
INSERT INTO `gate_node` VALUES ('5', 'user', '用户', '1', '2', '2', '3', '0');
INSERT INTO `gate_node` VALUES ('6', 'role', '角色', '1', '3', '2', '3', '0');
INSERT INTO `gate_node` VALUES ('7', 'addrole', '查看', '1', '1', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('8', 'insertrole', '添加', '1', '2', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('9', 'updaterole', '修改', '1', '2', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('10', 'deleterole', '删除', '1', '3', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('11', 'node', '资源查看', '1', '4', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('12', 'grantrole', '授权执行', '1', '5', '2', '3', '6');
INSERT INTO `gate_node` VALUES ('13', 'adduser', '查看', '1', '1', '2', '3', '5');
INSERT INTO `gate_node` VALUES ('14', 'insertuser', '添加', '1', '2', '2', '3', '5');
INSERT INTO `gate_node` VALUES ('15', 'updateuser', '修改', '1', '3', '2', '3', '5');
INSERT INTO `gate_node` VALUES ('16', 'delteuser', '删除', '1', '4', '2', '3', '5');
INSERT INTO `gate_node` VALUES ('34', 'password', '查看', '1', '1', '2', '3', '4');
INSERT INTO `gate_node` VALUES ('35', 'updatepasswd', '执行', '1', '2', '2', '3', '4');
INSERT INTO `gate_node` VALUES ('17', 'hospital', '医院信息', '1', '2', '0', '1', '0');
INSERT INTO `gate_node` VALUES ('18', 'hospital', '医院信息', '1', '1', '17', '2', '0');
INSERT INTO `gate_node` VALUES ('32', 'info', '服务器环境', '1', '2', '23', '3', '0');
INSERT INTO `gate_node` VALUES ('20', 'patient', '住院患者', '1', '2', '18', '3', '0');
INSERT INTO `gate_node` VALUES ('21', 'unit', '病区', '1', '3', '18', '3', '0');
INSERT INTO `gate_node` VALUES ('22', 'index', '首页', '1', '1', '0', '1', '0');
INSERT INTO `gate_node` VALUES ('23', 'index', '首页', '1', '1', '22', '2', '0');
INSERT INTO `gate_node` VALUES ('24', 'dev', '闸机设备', '1', '1', '23', '3', '0');
INSERT INTO `gate_node` VALUES ('25', 'guest', '访客信息', '1', '3', '0', '1', '0');
INSERT INTO `gate_node` VALUES ('26', 'guest', '访客信息', '1', '1', '25', '2', '0');
INSERT INTO `gate_node` VALUES ('27', 'index', '登记记录', '1', '1', '26', '3', '0');
INSERT INTO `gate_node` VALUES ('28', 'inout', '进出日志', '1', '2', '26', '3', '0');
INSERT INTO `gate_node` VALUES ('29', 'authority', '权限管理', '1', '4', '0', '1', '0');
INSERT INTO `gate_node` VALUES ('30', 'authority', '权限管理', '1', '1', '29', '2', '0');
INSERT INTO `gate_node` VALUES ('31', 'index', '权限信息', '1', '1', '30', '3', '0');
INSERT INTO `gate_node` VALUES ('33', 'help', '使用帮助', '1', '3', '23', '3', '0');
INSERT INTO `gate_node` VALUES ('36', 'activeuser', '启用禁用', '1', '5', '2', '3', '5');
INSERT INTO `gate_node` VALUES ('37', 'edit', '查看', '1', '1', '30', '3', '31');
INSERT INTO `gate_node` VALUES ('38', 'insert', '添加', '1', '2', '30', '3', '31');
INSERT INTO `gate_node` VALUES ('39', 'update', '修改', '1', '3', '30', '3', '31');
INSERT INTO `gate_node` VALUES ('40', 'delete', '删除', '1', '4', '30', '3', '31');
INSERT INTO `gate_node` VALUES ('41', 'unit', '查看', '1', '1', '18', '3', '21');
INSERT INTO `gate_node` VALUES ('42', 'authority/sel', '设置权限', '1', '2', '18', '3', '21');
INSERT INTO `gate_node` VALUES ('47', 'authority/edit?from=patient', '增加权限', '1', '1', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('48', 'authority/insert?from=patient', '增加权限执行', '1', '2', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('49', 'set?type=1', '陪注权限', '1', '3', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('50', 'setajax?type=1', '陪注权限执行', '1', '4', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('51', 'set?type=2', '陪同外出检查权限', '1', '5', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('52', 'setajax?type=2', '陪同外出检查权限执行', '1', '6', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('53', 'dep', '新增家属', '1', '7', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('54', 'depajax', '新增家属执行', '1', '8', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('55', 'depdelajax', '删除家属', '1', '9', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('56', 'otherset', '其他设置', '1', '10', '18', '3', '20');
INSERT INTO `gate_node` VALUES ('57', 'othersetajax', '其他设置执行', '1', '11', '18', '3', '20');

-- ----------------------------
-- Table structure for gate_object_authority
-- ----------------------------
DROP TABLE IF EXISTS `gate_object_authority`;
CREATE TABLE `gate_object_authority` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `authority_id` int(11) NOT NULL COMMENT '权限ID',
  `object_id` int(11) NOT NULL COMMENT '对象ID',
  `type` tinyint(1) NOT NULL COMMENT '类型1科室,2病房,3家属',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='权限对象表';

-- ----------------------------
-- Records of gate_object_authority
-- ----------------------------

-- ----------------------------
-- Table structure for gate_patient_authority
-- ----------------------------
DROP TABLE IF EXISTS `gate_patient_authority`;
CREATE TABLE `gate_patient_authority` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `zhuyuanhao` varchar(20) NOT NULL COMMENT '住院号',
  `kid` int(11) NOT NULL COMMENT '科室ID',
  `bid` int(11) NOT NULL COMMENT '病区ID',
  `rule` text COMMENT '时间人数规则格式json[{"11:30","12:30","1"},...]',
  `is_die` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否死亡,0否,1是,2已处理',
  `is_out` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否出院,0否,1是,2已处理',
  `is_operation` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否手术,0否,1是,2已处理',
  `is_icu` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否重症监护室,0否,1是,2已处理',
  `is_jc` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否检查,0否,1是,2已处理',
  `is_pz` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否陪住,0否,1是,2已处理',
  `is_operation_j` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否急诊手术,0否,1是,2已处理',
  `is_operation_z` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否择期手术,0否,1是,2已处理,3择期手术结束',
  `operation_z_date` date DEFAULT NULL COMMENT '择期手术日期',
  `b_auth` tinyint(1) NOT NULL DEFAULT '0' COMMENT '是否继承所属病区权限0是,1否',
  `die_date` date DEFAULT NULL COMMENT '死亡日期',
  `out_date` date DEFAULT NULL COMMENT '出院日期',
  `operation_date` date DEFAULT NULL COMMENT '手术结束日期',
  `operation_j_date` date DEFAULT NULL COMMENT '急诊手术结束日期',
  `in_status` tinyint(1) NOT NULL DEFAULT '0' COMMENT '住院当日设置超级权限状态0,未设0,已设1',
  `pz_status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '陪住权限1启用,0停用',
  `jc_status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '外出检查权限1启用,0停用',
  `authority_id` int(11) NOT NULL DEFAULT '0' COMMENT '从HIS读取过来的权限',
  `visit_cause` varchar(64) DEFAULT NULL COMMENT '探视原因从view_rwzb_visit_special里获取',
  PRIMARY KEY (`id`),
  UNIQUE KEY `i_zhuyuanhao` (`zhuyuanhao`)
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='患者权限表';

-- ----------------------------
-- Records of gate_patient_authority
-- ----------------------------

-- ----------------------------
-- Table structure for gate_role
-- ----------------------------
DROP TABLE IF EXISTS `gate_role`;
CREATE TABLE `gate_role` (
  `id` smallint(6) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(20) NOT NULL,
  `pid` smallint(6) DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `remark` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `status` (`status`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_role
-- ----------------------------
INSERT INTO `gate_role` VALUES ('1', 'administrator', '0', '1', '超级角色');

-- ----------------------------
-- Table structure for gate_role_user
-- ----------------------------
DROP TABLE IF EXISTS `gate_role_user`;
CREATE TABLE `gate_role_user` (
  `role_id` mediumint(9) unsigned DEFAULT NULL,
  `user_id` char(32) DEFAULT NULL,
  KEY `group_id` (`role_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_role_user
-- ----------------------------
INSERT INTO `gate_role_user` VALUES ('1', '1');

-- ----------------------------
-- Table structure for gate_user
-- ----------------------------
DROP TABLE IF EXISTS `gate_user`;
CREATE TABLE `gate_user` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `account` varchar(64) NOT NULL,
  `nickname` varchar(50) NOT NULL,
  `password` char(32) NOT NULL,
  `bind_account` varchar(50) NOT NULL,
  `last_login_time` int(11) unsigned DEFAULT '0',
  `last_login_ip` varchar(40) DEFAULT NULL,
  `login_count` mediumint(8) unsigned DEFAULT '0',
  `verify` varchar(32) DEFAULT NULL,
  `email` varchar(50) NOT NULL,
  `remark` varchar(255) NOT NULL,
  `create_time` int(11) unsigned NOT NULL,
  `update_time` int(11) unsigned NOT NULL,
  `status` tinyint(1) DEFAULT '0',
  `type_id` tinyint(2) unsigned DEFAULT '0',
  `info` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `account` (`account`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of gate_user
-- ----------------------------
INSERT INTO `gate_user` VALUES ('1', 'admin', '默认管理员', '493d82604503cf3a7c3e1c24781255cc', '', '1560751299', '::1', '34', null, '', '', '1559273182', '1559273182', '1', '0', '');
